@echo off

REM Nachfolgende Tabelle mit Auflistung der Textfarben, Quelle:
REM http://stackoverflow.com/questions/12572718/how-to-change-text-color-of-cmd-with-windows-batch-script-every-1-second
REM
REM 0 = Black       8 = Gray
REM 1 = Blue        9 = Light Blue
REM 2 = Green       A = Light Green
REM 3 = Aqua        B = Light Aqua
REM 4 = Red         C = Light Red
REM 5 = Purple      D = Light Purple
REM 6 = Yellow      E = Light Yellow
REM 7 = White       F = Bright White



@echo off
IF %1%.==.   GOTO Hinweis
IF %1% LSS 1 GOTO Hinweis
IF %1% GTR 4 GOTO Hinweis


REM Umschliessende Anfuehrungszeichen bei Zuweisung entfernen ("%~1"), s.a.
REM http://stackoverflow.com/questions/20831403/trouble-with-left-string-in-batch-file


:Hauptmenue






color 0a
CLS
echo . 
echo .    *** CheckCC:  C-Control I 1.1 Testsuite ***
echo .
echo .
echo .    
echo .
echo .    1) Verbindung und Hostmodus testen
echo .    
echo .    2) Komponenten mit dem Multimeter testen
echo .  
echo .    3) RS232 testen, Userprogramm sichern u. EEPROM testen
echo .  
echo .    4) Taktfrequenz und Timing testen
echo .
echo . 
echo .    0) Ende                                        v.0.1.2
echo .
echo .
echo .
echo .


REM Nachbildung der CHOICE-Anweisung, Quelle: https://dbaportal.eu/2012/11/08/replacement-for-choice-com-on-windows-7-x64/

set choice=
rem set /P choice="Select 1..5: "
 set /P choice="Auswahl:  (1,2,3,4, oder 0) "


::
:: I used ~0,1 to "substring" first character from the input
::
if not '%choice%'=='' set choice=%choice:~0,1%

if /I '%choice%'=='1' goto Teste_Hostmodus
if /I '%choice%'=='2' goto Teste_RS232-IC
if /I '%choice%'=='3' goto Teste_EEPROM
if /I '%choice%'=='4' goto Teste_Timing
if /I '%choice%'=='0' goto EndeCLS

::
:: if we came here then we know that user entered 
::
echo "%choice%" ist keine gueltige Auswahl
echo .
pause
GOTO Hauptmenue


:Teste_Hostmodus
color 9f
CLS
type MSG\HOST.txt
CALL 3rdparty\PuTTY\A_PuTTY.exe -serial COM%1 -sercfg 9600,8,n,1,N
GOTO Hauptmenue


:Teste_RS232-IC
color 9f
CLS
type MSG\RS232.txt
pause
GOTO Hauptmenue

:Teste_Timing
color 9f
CLS
type MSG\Timing.txt
pause
GOTO Hauptmenue


:Teste_EEPROM
IF EXIST ccupload.dat GOTO Alte_Sicherung_vorhanden

color 0a
CLS
type MSG\EEPROM.txt
IF EXIST ccupld_1.dat del ccupld_1.dat
IF EXIST ccupld_2.dat del ccupld_2.dat
pause

GOTO Auslesen_1

:Auslesen_1_wiederholen
type MSG\NEWLINE.txt
pause
type MSG\NEWLINE.txt

echo ?? Wiederhole erstes Auslesen (Oder jetzt beenden mittels 'Strg-C') 

:Auslesen_1

type MSG\NEWLINE.txt

echo **        
echo **    
echo **   Erstes Auslesen des Mikrokontrollers:  
echo **   
echo **

CALL ccuplwin.exe %1
IF NOT EXIST ccupload.dat GOTO Auslesen_1_wiederholen

ren ccupload.dat ccupld_1.dat 
type MSG\NEWLINE.txt
pause
type MSG\NEWLINE.txt

GOTO Auslesen_2

:Auslesen_2_wiederholen
type MSG\NEWLINE.txt
pause
type MSG\NEWLINE.txt

echo ?? Wiederhole erneutes Auslesen (Oder jetzt beenden mittels 'Strg-C') 

:Auslesen_1



:Auslesen_2

type MSG\NEWLINE.txt

echo **        
echo **   
echo **  Erneutes Auslesen zwecks Vergleich: 
echo **   
echo **
       
CALL ccuplwin.exe %1
IF NOT EXIST ccupload.dat GOTO Auslesen_2_wiederholen

type MSG\NEWLINE.txt
pause
type MSG\NEWLINE.txt

echo **        
echo **   
echo **  Wurden 2x identische Daten vom C-Control empfangen? 
echo **   
echo **
type MSG\NEWLINE.txt

fc ccupload.dat ccupld_1.dat /N > compare.txt

IF ERRORLEVEL 1 GOTO Dateien_ungleich

 

echo **        
echo **   SEHR GUT! - Ausgaben vom C-Control koennen offenbar
echo **   
echo **               fehlerfrei zum PC uebertragen werden.
echo **   

type MSG\NEWLINE.txt
pause
type MSG\NEWLINE.txt


IF NOT EXIST ccupload.dat GOTO Ausgabedatei_fehlt



type MSG\EEPROM-1.txt
pause
type MSG\EEPROM-2.txt
CALL omdlwin.exe L-E2TST.dat %1
pause


type MSG\EEPROM-3.txt
pause

CALL 3rdparty\PuTTY\A_PuTTY.exe -serial COM%1 -sercfg 9600,8,n,1,N

IF NOT EXIST ccupload.dat GOTO Ausgabedatei_fehlt


color
CLS
echo **  
echo **        
echo **
echo **   Dieser Test ist abgeschlossen
echo **   
echo **             
echo ** 
echo **   Folgende Kommandos koennen noch verwendet werden:
echo **                       
echo ** 
echo **   RESTORE [COMPORT]  - vorheriges Userprogrammm zurueck
echo ** 
echo **   TERMINAL [COMPORT] - Terminalprogramm oeffnen
echo ** 
echo ** 
echo **          
echo **   Anregungen oder Fehlermeldungen bitte ueber das
echo **   
echo **   Forum der Website http://ccintern.dharlos.de/forum/
echo **              
echo **   Stichwort:  ' CheckCC '    
echo **          
echo **
echo **
echo **
echo **
echo .

pause 

GOTO Ende









:Alte_Sicherung_vorhanden
color e0
cls
echo ?  
echo ?   
echo ?    
echo ?                                ACHTUNG!
echo ?
echo ?   Ein zuvor gesichertes C-Control Programm ist noch im Verzeichnis! 
echo ?
echo ?
echo ?    Um es nicht zu verlieren sollte zuerst die Datei "ccupload.dat"
echo ?    umbenannt oder in ein anderes Verzeichnis verschoben werden.
echo ?     
echo ?    
echo ?  Beispiel: ' ren ccupload.dat meinprg1.dat ' (eintippen)
echo ?
echo ?    
echo ?   
echo ?    
echo ?  Der Testablauf wird jetzt beendet. Nach Umbenennen oder Verschieben der
echo ?    
echo ?  Datei "ccupload.dat" kann 'CheckCC' dann manuell erneut gestartet werden.
echo ?
echo ?              
echo ?
echo ?
echo ?
echo .
PAUSE
GOTO Ende


:Ausgabedatei_fehlt
color e0
cls
echo ?
echo ?     Es konnte keine Sicherung des Userprogramms erstellt werden!
echo ?      
echo ?     Denkbar sind z.B. folgende Fehlerursachen:
echo ? 
echo ? - Die 5,0 Volt Versorgungsspannung ist unzureichend
echo ?   
echo ? - Der Autostart-Jumper ist noch gesteckt
echo ?
echo ? - Reset wurde nicht 2x hintereinander gedrueckt
echo ?   
echo ? - Die Serielle Schnittstelle am PC konnte nicht geoeffnet werden 
echo ? 
echo ? - Das Nullmodemkabel oder die kurze Flachbandleitung sind nicht korrekt
echo ?
echo ?   verschaltet. Vgl. hierzu auch:
echo ?
echo ?   http://ccintern.dharlos.de/forum/lesen.php?eintrag=16446
echo ?
echo ? - Der externe Programmspeicherbaustein (24C65) ist fatal defekt, oder
echo ?
echo ?   dessen I2C Busleitungen sind im Bereich der Schaltung kurzgeschlossen
echo ?    
echo ? - Der Quarz schwingt mit einer anderen Frequenz als 4,000 MHz
echo ?    
echo ? - Dieses Tool wurde von CD-ROM gestartet oder in einem Verzeichnis
echo ?   
echo ?   das schreibgeschuetzt ist. 
echo ?
echo .   
echo . *** Der Testablauf wird jetzt vorzeitig beendet ***
echo .
echo .
echo .
PAUSE
GOTO Hauptmenue


:Dateien_ungleich
IF EXIST ccupload.dat del ccupload.dat
pause
color e0
cls
echo ?
echo ?     Die Dateien sind nicht gleich!
echo ?      
echo ?     Dies koennte auf folgende Fehlerursachen hindeuten: 
echo ? 
echo **        
echo **   Offenbar konnten vom PC keine Ausgaben des C-Control fehlerfrei
echo **   
echo **   empfangen werden.
echo **    
echo ? 
echo ? - Versorgungsspannung?
echo ?
echo ? - 16-poliger RS232 Baustein?
echo ?
echo ? - Externer Programmspeicherbaustein (24C65) fatal defekt?
echo ?
echo ? - Externe Quarzfrequenz fernab von 4,000 MHz?
echo ?    
echo ? - Dieses Tool wurde von CD-ROM gestartet oder in einem Verzeichnis
echo ?   
echo ?   das schreibgeschuetzt ist. 
echo ?
echo .   
echo .  Ergebnis des Dateivergleichs aus der Textdatei 'compare.txt':
type MSG\NEWLINE.txt
type compare.txt
PAUSE
GOTO Hauptmenue


:Hinweis
@echo off
color 0F
cls
echo ??????
echo ?????      Keine unterstuetzte Portnummer angegeben!
echo ????              
echo ???  (Dieses Tool bitte ueber die Kommandozeile starten)
echo ??
echo ?       Syntax:   CHECKCC [COMPORT '1'...'4']
echo ?
echo ?     Beispiele:   checkcc 2 , checkcc 1 , checkcc 4
echo ?    
echo ? 
echo ?     Dieses Testprogramm befindet sich noch in der
echo ?  
echo ?     Entwicklungphase. Anwendung auf eigenes Risiko!
echo ?  
echo ?     Anregungen oder Fehlermeldungen bitte ueber das
echo ?  
echo ?     Forum der Website http://ccintern.dharlos.de/forum/
echo ?  
echo ?     Stichwort:  ' CheckCC '
echo ??
echo ???
echo ????
echo ?????
echo ??????
echo .
PAUSE
goto Ende

:EndeCLS
color
cls


:Ende
REM In frueheren Windows-Versionen bleibt das DOS-Fenster evt. geoeffnet -
echo Du kannst dieses Fenster jetzt schliessen, oder einen neuen Befehl eintippen.
